Botan: Botan::AES_ISA_Engine Class Reference

Botan 1.10.16

Public Member Functions | List of all members
Botan::AES_ISA_Engine Class Reference

`#include <aes_isa_engine.h>`

Inheritance diagram for Botan::AES_ISA_Engine:

## Public Member Functions
BlockCipher * | find_block_cipher (const SCAN_Name &, Algorithm_Factory &) const
virtual HashFunction * | find_hash (const SCAN_Name &algo_spec, Algorithm_Factory &af) const
virtual MessageAuthenticationCode * | find_mac (const SCAN_Name &algo_spec, Algorithm_Factory &af) const
virtual PBKDF * | find_pbkdf (const SCAN_Name &algo_spec, Algorithm_Factory &af) const
virtual StreamCipher * | find_stream_cipher (const SCAN_Name &algo_spec, Algorithm_Factory &af) const
virtual Keyed_Filter * | get_cipher (const std::string &algo_spec, Cipher_Dir dir, Algorithm_Factory &af)
virtual PK_Ops::Decryption * | get_decryption_op (const Private_Key &key) const
virtual PK_Ops::Encryption * | get_encryption_op (const Public_Key &key) const
virtual PK_Ops::Key_Agreement * | get_key_agreement_op (const Private_Key &key) const
virtual PK_Ops::Signature * | get_signature_op (const Private_Key &key) const
virtual PK_Ops::Verification * | get_verify_op (const Public_Key &key) const
virtual Modular_Exponentiator * | mod_exp (const BigInt &n, Power_Mod::Usage_Hints hints) const
std::string | provider_name () const

## Detailed Description

Engine for implementations that hook into CPU-specific AES implementations (eg AES-NI, VIA C7, or AMD Geode)

Definition at line 19 of file aes_isa_engine.h.

## Member Function Documentation

## ◆ find_block_cipher()

BlockCipher * Botan::AES_ISA_Engine::find_block_cipher | ( | const SCAN_Name & | algo_spec,
|  | Algorithm_Factory & | af
| ) |  | const
| virtual

Parameters

  algo_spec | the algorithm name/specification
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented from Botan::Engine.

Definition at line 18 of file aes_isa_engine.cpp.

References Botan::SCAN_Name::algo_name(), and Botan::CPUID::has_aes_ni().

Referenced by provider_name().

20 {
21 #if defined(BOTAN_HAS_AES_NI)
22 if(CPUID::has_aes_ni())
23 {
24 if(request.algo_name() == "AES-128")
25 return new AES_128_NI;
26 if(request.algo_name() == "AES-192")
27 return new AES_192_NI;
28 if(request.algo_name() == "AES-256")
29 return new AES_256_NI;
30 }
31 #endif
32
33 return 0;
34 }
Botan::CPUID::has_aes_ni
static bool has_aes_ni()
Definition: cpuid.h:70

## ◆ find_hash()

HashFunction * Botan::Engine::find_hash | ( | const SCAN_Name & | algo_spec,
|  | Algorithm_Factory & | af
| ) |  | const
| virtualinherited

Parameters

  algo_spec | the algorithm name/specification
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Core_Engine, Botan::OpenSSL_Engine, Botan::Dynamically_Loaded_Engine, Botan::Assembler_Engine, and Botan::SIMD_Engine.

Definition at line 27 of file engine.cpp.

29 {
30 return 0;
31 }

## ◆ find_mac()

MessageAuthenticationCode * Botan::Engine::find_mac | ( | const SCAN_Name & | algo_spec,
|  | Algorithm_Factory & | af
| ) |  | const
| virtualinherited

Parameters

  algo_spec | the algorithm name/specification
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Core_Engine, and Botan::Dynamically_Loaded_Engine.

Definition at line 34 of file engine.cpp.

36 {
37 return 0;
38 }

## ◆ find_pbkdf()

PBKDF * Botan::Engine::find_pbkdf | ( | const SCAN_Name & | algo_spec,
|  | Algorithm_Factory & | af
| ) |  | const
| virtualinherited

Parameters

  algo_spec | the algorithm name/specification
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, and Botan::Core_Engine.

Definition at line 41 of file engine.cpp.

43 {
44 return 0;
45 }

## ◆ find_stream_cipher()

StreamCipher * Botan::Engine::find_stream_cipher | ( | const SCAN_Name & | algo_spec,
|  | Algorithm_Factory & | af
| ) |  | const
| virtualinherited

Parameters

  algo_spec | the algorithm name/specification
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Core_Engine, Botan::OpenSSL_Engine, and Botan::Dynamically_Loaded_Engine.

Definition at line 20 of file engine.cpp.

22 {
23 return 0;
24 }

## ◆ get_cipher()

Keyed_Filter * Botan::Engine::get_cipher | ( | const std::string & | algo_spec,
|  | Cipher_Dir | dir,
|  | Algorithm_Factory & | af
| ) |  |
| virtualinherited

Return a new cipher object

Parameters

  algo_spec | the algorithm name/specification
  dir | specifies if encryption or decryption is desired
  af | an algorithm factory object

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, and Botan::Core_Engine.

Definition at line 54 of file engine.cpp.

57 {
58 return 0;
59 }

## ◆ get_decryption_op()

PK_Ops::Decryption * Botan::Engine::get_decryption_op | ( | const Private_Key & | key | ) | const
| virtualinherited

Return a new operator object for this key, if possible

Parameters

  key | the key we want an operator for

Returns
  newly allocated operator object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 86 of file engine.cpp.

87 {
88 return 0;
89 }

## ◆ get_encryption_op()

PK_Ops::Encryption * Botan::Engine::get_encryption_op | ( | const Public_Key & | key | ) | const
| virtualinherited

Return a new operator object for this key, if possible

Parameters

  key | the key we want an operator for

Returns
  newly allocated operator object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 80 of file engine.cpp.

81 {
82 return 0;
83 }

## ◆ get_key_agreement_op()

PK_Ops::Key_Agreement * Botan::Engine::get_key_agreement_op | ( | const Private_Key & | key | ) | const
| virtualinherited

Return a new operator object for this key, if possible

Parameters

  key | the key we want an operator for

Returns
  newly allocated operator object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 62 of file engine.cpp.

63 {
64 return 0;
65 }

## ◆ get_signature_op()

PK_Ops::Signature * Botan::Engine::get_signature_op | ( | const Private_Key & | key | ) | const
| virtualinherited

Return a new operator object for this key, if possible

Parameters

  key | the key we want an operator for

Returns
  newly allocated operator object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 68 of file engine.cpp.

69 {
70 return 0;
71 }

## ◆ get_verify_op()

PK_Ops::Verification * Botan::Engine::get_verify_op | ( | const Public_Key & | key | ) | const
| virtualinherited

Return a new operator object for this key, if possible

Parameters

  key | the key we want an operator for

Returns
  newly allocated operator object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 74 of file engine.cpp.

75 {
76 return 0;
77 }

## ◆ mod_exp()

Modular_Exponentiator * Botan::Engine::mod_exp | ( | const BigInt & | n,
|  | Power_Mod::Usage_Hints | hints
| ) |  | const
| virtualinherited

Parameters

  n | the modulus
  hints | any use hints

Returns
  newly allocated object, or NULL

Reimplemented in Botan::Dynamically_Loaded_Engine, Botan::GMP_Engine, Botan::OpenSSL_Engine, and Botan::Core_Engine.

Definition at line 48 of file engine.cpp.

50 {
51 return 0;
52 }

## ◆ provider_name()

std::string Botan::AES_ISA_Engine::provider_name | ( |  | ) | const
| inlinevirtual

Returns
  name of this engine

Implements Botan::Engine.

Definition at line 22 of file aes_isa_engine.h.

References find_block_cipher().

22 { return "aes_isa"; }

The documentation for this class was generated from the following files:

- src/engine/aes_isa_eng/aes_isa_engine.h
- src/engine/aes_isa_eng/aes_isa_engine.cpp